/*+------------------------------------------------------------------+
//|                                                  SpookySpots.mq4 |
//|                                                           Gooly  |
//|                                              http://www.mql5.com |
//|
//+------------------------------------------------------------------*/
#property copyright "Gooly"
#property strict

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Red   
#property indicator_color2 Lime 
#property indicator_color3 clrNONE
#property indicator_color4 White

//---- input parameters

extern ENUM_APPLIED_PRICE Price1  = PRICE_CLOSE;
extern  int Ma_Period = 32;
extern  int Ma_MinChgPoint = 2;
//----
double   ma[], SeBuff[], BuBuff[], Trend[];

bool New_Bar = false;  
   double _cP;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorShortName("SpookySpots");
   IndicatorDigits(Digits);
   SetIndexBuffer(     0, SeBuff);       
   SetIndexStyle(      0, DRAW_LINE, STYLE_SOLID, 1);
   SetIndexEmptyValue( 0, 0.0);
   SetIndexLabel(      0, "Spooky-Sell");
//---  
   SetIndexBuffer(     1, BuBuff);       
   SetIndexStyle (     1, DRAW_LINE, STYLE_SOLID, 1);
   SetIndexEmptyValue( 1, 0.0);
   SetIndexLabel(      1, "Spooky-Buy");
//---   
   
   SetIndexBuffer(    2, ma);
   SetIndexStyle(     2, DRAW_NONE); //,STYLE_SOLID);
   SetIndexLabel(     2, "Spooky-Value");
   
   SetIndexBuffer(    3, Trend);
   SetIndexStyle(     3, DRAW_ARROW); //,STYLE_SOLID);
   SetIndexArrow(     3, 159);//Pos Chg
   SetIndexLabel(     3, "Spooky-Trend");

	_cP=Ma_MinChgPoint*Point;

   return(0);
  }

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
datetime TmeBar;
bool   IsNewBar;
int TRND =0;
int start() {
//==========================================================  
   int i=-1, I, counted_bars = IndicatorCounted();     
   if(counted_bars < 0 ) return(0);
   if(Bars < 500 )       return(0); 
   I = (counted_bars==0) ? Bars-2 : Bars - counted_bars-1;
   if ( TmeBar != Time[0] || counted_bars<10 ) { IsNewBar = true; TmeBar = Time[0]; } else IsNewBar = false;
   i=I;
//------------------------------------------------------- 11 --
   while( i >= 0 ) { 
		BuBuff[i] = SeBuff[i] = 0.0;
		double m1 = iMA(NULL,0,Ma_Period,0,0,Price1,i);
		       
		if ( i > 0 && IsNewBar ){
			ma[i] = m1;
			if     ( ma[i] > ma[i+1]+_cP )  { BuBuff[i] = ma[i]; SeBuff[i] = 0.0;  } // BuBuff[i+1] = ma[i+1]; 
			else if( ma[i] < ma[i+1]-_cP )  { BuBuff[i] = 0.0;   SeBuff[i] = ma[i];} // SeBuff[i+1] = ma[i+1];
			else                            { BuBuff[i] = BuBuff[i+1]; SeBuff[i] = SeBuff[i+1]; }
		} else {
			ma[i] = m1;
			if     ( (ma[i]>ma[i+1] && BuBuff[i+1]>0) || ma[i] > ma[i+1]+_cP ) { BuBuff[i] = ma[i]; SeBuff[i] = 0.0;  } // BuBuff[i+1] = ma[i+1];
			else if( (ma[i]<ma[i+1] && SeBuff[i+1]>0) || ma[i] < ma[i+1]-_cP ) { BuBuff[i] = 0.0;   SeBuff[i] = ma[i];} // SeBuff[i+1] = ma[i+1];
			else                                                               { BuBuff[i] = BuBuff[i+1]; SeBuff[i] = SeBuff[i+1]; }
		}		
		if ( i>0 ) { // 
			if ( ma[i] == BuBuff[i] && BuBuff[i+1] == 0.0 && TRND!= 1 ) { TRND= 1; Trend[i-1] = Open[i-1]; }
			if ( ma[i] == SeBuff[i] && SeBuff[i+1] == 0.0 && TRND!=-1 ) { TRND=-1; Trend[i-1] = Open[i-1]; }
		}
	i--;
	}
    //------- 
   return(0);
}
 
 //=========================================================================== 

